/***************************************************************************
                          lum-control-factory.c  -  Lumiere Control Factory
                             -------------------
    begin                : jeu jun  30 14:49:47 BST 2002
    copyright            : (C) 2002 by Stphane Konstantaropoulos
    email                : ssk01@aber.ac.uk | stephanek@brutele.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/*
 * CVS block
 *
 * $Author: stephanek $
 * $Revision: 1.5 $
 * $Date: 2003/02/07 03:24:49 $
 * $Log: lum-control-factory.c,v $
 * Revision 1.5  2003/02/07 03:24:49  stephanek
 * added gtk-xine interfacing with libxine.
 * lost stability, cannot load a second file without crashing...
 *
 * added interface lum-player
 * getting ready for GlPlayer...
 *
 * Revision 1.4  2003/01/15 18:26:25  stephanek
 * configuration created
 * no more compilation warnings
 *
 * Revision 1.3  2003/01/14 11:47:46  stephanek
 * :q
 * :q
 * :q
 * :q
 *
 * Revision 1.2  2003/01/08 22:02:03  stephanek
 * Aspect ratio keeping implemented.
 * Issues: Need to set the background black
 *
 * Revision 1.1.1.1  2003/01/03 02:09:01  stephanek
 * Imported sources
 *
 */

#include <config.h>
#include <string.h>
/* This must be included _before_ bonobo-generic-factory.h,
 * otherwise BONOBO_ACTIVATION_FACTORY won't initialize the
 * gtk and other gui stuff! */
#include <bonobo/bonobo-ui-main.h> 

#include <bonobo.h>
#include <lum-control.h>

static BonoboObject *lum_player_factory (BonoboGenericFactory *this,
					const char *oaf_iid,
					void *data)
{
	BonoboObject *retval;

	g_return_val_if_fail (this != NULL, NULL);
	g_return_val_if_fail (oaf_iid != NULL, NULL);

	if (!strcmp (oaf_iid, "OAFIID:GNOME_LUM_Control")) {
		retval = BONOBO_OBJECT (lum_control_new ());
	} else {
		g_warning ("Unknown IID `%s' requested", oaf_iid);
		return NULL;
	}

	if(BONOBO_IS_OBJECT(retval))
		return retval;
	else
		return NULL;
}

int main (int argc, char *argv [])					
{									
	BonoboGenericFactory *factory;
	char *tmp = bindtextdomain (PACKAGE, GNOMELOCALEDIR);                       
//	bind_textdomain_codeset (PACKAGE, "UTF-8");                     
	tmp = textdomain (PACKAGE);
	
	BONOBO_FACTORY_INIT ("lumiere-control", VERSION, &argc, argv);
									
	factory = bonobo_generic_factory_new ("OAFIID:GNOME_LUM_Factory",
					    lum_player_factory, NULL);
	if(!factory)
		g_error ("Registration of Bonobo Lumiere factory failed");
		/*
	 *  make sure we're unreffing upon exit;
	 *  enter the bonobo main loop
	 */
	bonobo_running_context_auto_exit_unref (BONOBO_OBJECT(factory));
	bonobo_main ();
	free(tmp);
	return EXIT_SUCCESS;
}    
