/***************************************************************************
                          lum-session.c  -  Lumiere Session Management
                             -------------------
    begin                : Wed Jun  12 02:08:47 BST 2002
    copyright            : (C) 2002 by Stphane Konstantaropoulos
    email                : ssk01@aber.ac.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/*
 * CVS block
 *
 * $Author: stephanek $
 * $Revision: 1.1.1.1 $
 * $Date: 2003/01/03 02:09:01 $
 * $Log: lum-session.c,v $
 * Revision 1.1.1.1  2003/01/03 02:09:01  stephanek
 * Imported sources
 *
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <libgnome/gnome-config.h>
#include "lum-window.h"
#include "lum-session.h"

/**
 * static func declaration
 */
static void load_uri_with_role (const char *uri, const char *role);


static void load_uri_with_role (const char *uri, const char *role)
{
	GtkWidget *window;

	window = lum_window_new ();
	lum_window_open (LUM_WINDOW (window), uri);
	gtk_window_set_role (GTK_WINDOW (window), role);
	gtk_widget_show (window);
}

/**
 * Modif, one window only... hope it is not NULL only when it is not NULL
 * You see what I mean
 */
void session_save (const char *config_prefix)
{
	LumWindow *window;

	gnome_config_push_prefix (config_prefix);

	if ((window = lum_window_get_window ()) != NULL) {
		const char *uri;
		const char *role;

		if((uri = lum_window_get_uri (window))){
			role = gtk_window_get_role (GTK_WINDOW (window));
			g_assert (role != NULL);
			gnome_config_set_string ("role", role);
			gnome_config_set_string ("uri", uri);
		}
	}

	gnome_config_pop_prefix ();
	gnome_config_sync ();
}

/**
 * modif encore, this should work no problem
 */
void session_load (const char *config_prefix)
{
	char *role_value;
	char *uri_value = NULL;

	gnome_config_push_prefix (config_prefix);

	role_value = gnome_config_get_string ("role");
	if (role_value){
		uri_value = gnome_config_get_string ("uri");
		if (!uri_value) {
			g_message (
				"Got role/ID %s but no URI key!  Stopping session load.",
				role_value);
			g_free (role_value);
		}else 
			load_uri_with_role (uri_value, role_value);
	}

	g_free (role_value);
	g_free (uri_value);

	gnome_config_pop_prefix ();
}
